Imports System.IO
Imports PBasic
Imports PClient
Imports PView
Imports PCSS
Imports MapviewLib
Imports PService
Imports DataviewLib
Imports GDO




Public Class TransformacioCarto
    Dim Controles As New Collection
    Dim controlesTaula As New Collection
    Dim controlesCamps As New Collection
    Dim ColCampsCruilles As New Collection
    Dim ColCampsTrams As New Collection
    Dim geoApp As Application
    Dim objDB As GDO.GDatabase, objTbl As GDO.GTableDef
    Dim objFlds As GDO.GFields, objFld As GDO.GField
    Dim Recordset1 As GDO.GRecordset
    Dim Camp As GDO.GField
    Dim objConfig As configuracio = New configuracio

    '***************************
    Dim objEvSrv As PBasic.EventServer, objLine As PBasic.LineGeometry
    Dim objGeomEditBici As PClient.GeometryEditService
    Dim objGeomEditPasPeatons As PClient.GeometryEditService
    Dim objGeomEditPeat As PClient.GeometryEditService
    Dim objGeomEditFletxa As PClient.GeometryEditService
    Dim objGeomEditFletxa2 As PClient.GeometryEditService
    '*******************
    Dim objOrntPnt As PBasic.OrientedPointGeometry
    Dim objGeomEdit As PClient.GeometryEditService
    Dim objStyleService As New PView.StyleService
    Dim objstyle As PView.StyleDefinition

    Dim objLE As PView.LegendEntry
    Dim selPntNum As Integer ' Keep track of mouse clicks
    Dim pntX As Double, pntY As Double, pntZ As Double
    Dim objRS As GDO.GRecordset
    Dim objConn As New PClient.Connection
    Dim objOP As PClient.OriginatingPipe
    Dim objSmart As New PBasic.SmartLocateService
    Dim objLoc As New PView.LocatedObjectsCollection
    Dim objPntGeom As New PBasic.PointGeometry
    Dim objOPipe As PClient.OriginatingPipe
    Dim objCPoint As New PPipe.CenterPointPipe
    'Dim objLE As New PView.LegendEntry
    Dim MapFunct As Integer
    Dim objGeomEditObra As PClient.GeometryEditService
    Dim objEvSrvObra As PBasic.EventServer, objOrntPntObra As PBasic.OrientedPointGeometry
    Dim objStyleServiceObra As New PView.StyleService
    Dim objstyleObra As PView.StyleDefinition
    Dim objstylePunts As PView.StyleDefinition
    Private Sub frmTransCarto_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Width = 400
        Me.Height = 520
        'Fem una colecci de controls per a omplir els combobox
        
        Controles.Add(cmbArxiuCarrer)
        
        'Fem una coleccio amb el combos de les taules
        controlesTaula.Add(cmbTaulaCarrer)
        controlesTaula.Add(cmbTaulaAmplada)
        controlesTaula.Add(cmbTaulaNodes)
        'fem una coleccio per a omplir els combos dels camps
        'controlesCamps.Add(cmbCampsSentit)
        controlesCamps.Add(cmbCampsCarrils)
        controlesCamps.Add(cmbCampsPeatonal)
        controlesCamps.Add(cmbCampsBici)
        controlesCamps.Add(cmbCampsCarrer)


        objEvSrvObra = CreateObject("Geomedia.EventServer")
        EventControl1.HesitationTime = 5
        EventControl1.AddMapView(GMMapView1.Dispatch, objEvSrvObra)

        
        ' Create Oriented Point object
        objOrntPntObra = CreateObject("GeoMedia.OrientedPointGeometry")
        With objOrntPntObra
            .Orientation.I = 1
            .Orientation.J = 0
            .Orientation.K = 0

        End With

        ' Create Geometry Edit Service object
        objGeomEditObra = CreateObject("GeoMedia.GeometryEditService")
        objGeomEditObra.MapView = GMMapView1.Dispatch

    End Sub
    Private Sub btnCarpeta_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCarpeta.Click

        folder1.ShowDialog()
        'Mirem que la ruta acabi en "\"
        If (folder1.SelectedPath.EndsWith("\")) Then
            txtCarpeta.Text = folder1.SelectedPath
            objConfig.rutaDades = txtCarpeta.Text
        Else
            txtCarpeta.Text = folder1.SelectedPath & "\"
        End If
        txtCarpeta.ForeColor = Color.Blue
        btnSig.Enabled = True
    End Sub
    Private Sub btnConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConfig.Click
        'Mostrem el cuadre de dialeg per a selleccionar l'arxiu de configuraci
        OpenFileDialog1.FileName = "Tria l'arxiu de configuraci:"
        OpenFileDialog1.Filter = "Fitxer configuraci|*.cnf| tots els arxius|*.*"
        If (OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK) Then
            txtConfiguracio.Text = OpenFileDialog1.FileName
            objConfig.objGeoWorkspace = OpenFileDialog1.FileName
        Else
            txtConfiguracio.Text = ""
        End If
        btnActualitza.Visible = True
    End Sub
    Private Sub btnSig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSig.Click
        If (txtCarpeta.Text <> "Text Obligatori") Then
            TabControl1.SelectedIndex = 1
        Else
            MsgBox("Tria la carpeta amb els arxius")
        End If
    End Sub
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnActualitza.Click
        'carreguem les dades de l'arxiu de configuraci
        If (txtConfiguracio.Text <> "Text opcional") Then
            objConfig.fnLlegirdades(txtConfiguracio.Text)
            With objConfig
                txtCarpeta.Text = .rutaDades
                cmbArxiuCarrer.Text = .clCarrer.Arxiu
                cmbTaulaCarrer.Text = .clCarrer.Taula
                cmbCampsCarrer.Text = .clCarrer.Camp
                cmbCampsSentit.Text = .clSentit.Camp
                cmbCampsCarrils.Text = .clCarrils.Camp
                cmbTaulaAmplada.Text = .clAmplada.Taula
                cmbCampsAmplada.Text = .clAmplada.Camp
                cmbCampsPeatonal.Text = .clPeatonal.Camp
                cmbCampsBici.Text = .clBici.Camp
                cmbCampsSentit.Text = .clSentit.Camp
                'La simbologia
                InteriorPeatonal.BackColor = .smCarrilPeatonal.Interior
                PeatonalContorn.BackColor = .smCarrilPeatonal.Contorn
                interiorBici.BackColor = .smCarrilBici.Interior
                contornBici.BackColor = .smCarrilBici.Contorn
                contornCarrils.BackColor = .smCarril.Interior
                contornCarrils.BackColor = .smCarril.Contorn
                interiorCarrers.BackColor = .smCarrers.Interior
                contornCarrers.BackColor = .smCarrers.Contorn
                sepCarrils.BackColor = .smSeparacioCarril.colorSimbol
                btnSimbolBici.BackColor = .smSimbolBici.colorSimbol
                btnSimbolPeatonal.BackColor = .smSimbolPeatonal.colorSimbol
                btnSimbolFetxa.BackColor = .smSimbolFletxa.colorSimbol
                btnsimbolFletxaDoble.BackColor = .smSimbolFletxaDoble.colorSimbol
                cmbLineStyle.Text = .smSeparacioCarril.style
                cmbTaulaNodes.Text = .clNodes.Taula
                btncolorPasVianants.BackColor = .smSimbolPdV.colorSimbol
                btnsimbolObres.BackColor = .smSimbolObres.colorSimbol



                txtNomBici.Text = .smSimbolBici.Arxiu

                txtMidaBici.Text = .smSimbolBici.Mida
                txtNomPeatonal.Text = .smSimbolPeatonal.Arxiu
                txtMidaPeatonal.Text = .smSimbolPeatonal.Mida
                txtNomFletxaDoble.Text = .smSimbolFletxaDoble.Arxiu
                txtMidaFletxaDoble.Text = .smSimbolFletxaDoble.Mida
                txtNomFletxa.Text = .smSimbolFletxa.Arxiu
                txtMidaFletxa.Text = .smSimbolFletxa.Mida
                txtNomPdV.Text = .smSimbolPdV.Arxiu
                txtMidaPdv.Text = .smSimbolPdV.Mida
                txtNomObres.Text = .smSimbolObres.Arxiu
                txtMidaObres.Text = .smSimbolObres.Mida


            End With 'activem el bot de continuar
            btnSig.Enabled = True
        Else
            MsgBox("Tria l'arxiu amb la configuraci", MsgBoxStyle.Critical)
        End If


    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Try 'Generem les taules i les omplim, cridem a les funcions i anem notificant els processos
            lblStatus.Text = "Creant taules..."
            ListBoxResultats.Items.Add("Creant taules...")
            Funcions.crearTaula(txtRutaSortida.Text, txtArxiuSortida.Text)
            lblStatus.Text = "Estructura de taules creada correctament."
            ListBoxResultats.Items.Add("Estructura de taules creada correctament.")
            Me.Refresh()
            ListBoxResultats.Items.Add("Creant Carrers...")
            lblStatus.Text = "Creant poligons"
            Funcions.crearPoligonsCarrers(objConfig, progressStatus, txtRutaSortida.Text, txtArxiuSortida.Text, Me)
            lblStatus.Text = "Poligons creada correctament."
            ListBoxResultats.Items.Add("Taula dels Carrers creada")
            Me.Refresh()
            ListBoxResultats.Items.Add("Creant la taula de la separaci dels carrils")
            lblStatus.Text = "Separacio carrils"
            Funcions.crearEixosCarrils(objConfig, progressStatus, txtRutaSortida.Text, txtArxiuSortida.Text, Me)
            lblStatus.Text = "Separacio carrils creat."
            ListBoxResultats.Items.Add("Taula de separaci de carrils creada")
            Me.Refresh()
            'Fem la taula dels carrils bici i peatonal
            ListBoxResultats.Items.Add("Creant la taula dels carrils bici...")
            lblStatus.Text = "Carrils bici"
            Funcions.crearPoligonsTipus("Carrils_Bici", objConfig.clBici.Camp, objConfig, progressStatus, txtRutaSortida.Text, txtArxiuSortida.Text, Me)
            lblStatus.Text = "Carrils Bici creat."
            ListBoxResultats.Items.Add("Taula carrils bici creada.")
            ListBoxResultats.Items.Add("Creant la taula dels carrils Peatonals...")
            lblStatus.Text = "Creant Peatonals"
            Funcions.crearPoligonsTipus("Carrils_Peatonals", objConfig.clPeatonal.Camp, objConfig, progressStatus, txtRutaSortida.Text, txtArxiuSortida.Text, Me)
            lblStatus.Text = "Carrils Peatonals creat."
            ListBoxResultats.Items.Add("Taula carrils peatonals creada.")
            ListBoxResultats.Items.Add("Creant la taula amb tots els carrils...")
            lblStatus.Text = "Creant carrils"
            Funcions.crearPoligonsTipus("Carrils", objConfig.clCarrer.Camp, objConfig, progressStatus, txtRutaSortida.Text, txtArxiuSortida.Text, Me)
            lblStatus.Text = "Carrils creat."
            ListBoxResultats.Items.Add("Taula dels carrils creada.")
            ListBoxResultats.Items.Add("Creant la taula dels nodes...")
            lblStatus.Text = "Creant Nodes"
            Funcions.crearNodes(objConfig, progressStatus, txtRutaSortida.Text, txtArxiuSortida.Text, Me)
            lblStatus.Text = "Nodes creats."
            ListBoxResultats.Items.Add("Taula dels Nodes creada.")
            ListBoxResultats.Items.Add("Procs acabat.")

            'activem el bot per a continuar
            btnSigTaules.Enabled = True
            Button6.Enabled = False
        Catch ex As Exception
            MsgBox(ex.Message & ",revisa les dades.", MsgBoxStyle.Exclamation)
            ListBoxResultats.Items.Add(ex.Message & ",revisa les dades.")
        End Try
    End Sub
    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        folder1.ShowDialog() 'Triem la carpeta de l'arxiu de sortida
        'Mirem que la ruta acabi en "\"
        If (folder1.SelectedPath.EndsWith("\")) Then
            txtRutaSortida.Text = folder1.SelectedPath
        Else
            txtRutaSortida.Text = folder1.SelectedPath & "\"
        End If
    End Sub
    Private Sub cmbTaulaCarrer_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'omplim els combos amb els camps
        If cmbArxiuCarrer.Text.Contains("\") Then 'Si l'arxiu cont la ruta el carreguem
            Funcions.OmplircolCmbColumnes(cmbArxiuCarrer.Text, cmbTaulaCarrer.Text, controlesCamps)
        Else
            Funcions.OmplirCmbColumnes(txtCarpeta.Text & cmbArxiuCarrer.Text, cmbTaulaCarrer.Text, cmbCampsCarrer)
        End If
    End Sub
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'Guardem les dades a l'onjecte objConfig de la classe configuracio
        With objConfig
            .clCarrer.Arxiu = cmbArxiuCarrer.Text
            .clCarrer.Camp = cmbCampsCarrer.Text
            .clSentit.Camp = cmbCampsSentit.Text
            .clCarrils.Camp = cmbCampsCarrils.Text
            .clAmplada.Taula = cmbTaulaAmplada.Text
            .clAmplada.Arxiu = cmbArxiuCarrer.Text
            .clAmplada.Camp = cmbCampsAmplada.Text
            .clPeatonal.Camp = cmbCampsPeatonal.Text
            .clBici.Camp = cmbCampsBici.Text
            .clCarrer.Taula = cmbTaulaCarrer.Text
            .clSentit.Taula = cmbTaulaAmplada.Text
            .clAmplada.Taula = cmbTaulaAmplada.Text
            .clNodes.Taula = cmbTaulaNodes.Text
        End With
        TabControl1.SelectedIndex = 2
    End Sub
    Private Sub EventControl1_ClickEvent(ByVal sender As System.Object, ByVal e As AxGMEventControlLib._DGMEventControlEvents_ClickEvent) Handles EventControl1.ClickEvent

        Dim I As Integer
        If e.button = 1 Then
            e.mapviewDispatch.BeginDynamic()

            Select Case MapFunct

                Case 1 'Zoom Area
                    If selPntNum = 0 Then
                        pntX = e.worldX
                        pntY = e.worldY
                        pntZ = e.worldZ
                        selPntNum = 1
                        ToolStripStatusLabel1.Text = "Selecciona el segon punt"
                    Else
                        GMMapView1.ZoomArea(pntX, pntY, pntZ, e.worldX, e.worldY, e.worldZ)
                        selPntNum = 0
                        ToolStripStatusLabel1.Text = ""
                    End If
                Case 2 'Afegir simbol obra
                    objOrntPntObra.Origin.X = e.worldX
                    objOrntPntObra.Origin.Y = e.worldY
                    objOrntPntObra.Origin.Z = e.worldZ

                    ' Display points
                    objGeomEditObra.AppendGeometry(objOrntPntObra, objstyleObra)

                Case 3 ' pan
                    pntX = e.worldX
                    pntY = e.worldY
                    pntZ = e.worldZ
                    selPntNum = 1

                Case 4 ' Fit selected items

                    objPntGeom.Origin.X = e.worldX
                    objPntGeom.Origin.Y = e.worldY
                    objPntGeom.Origin.Z = e.worldZ

                    objLoc.Clear()
                    GMMapView1.MapViewSelectedObjects.Clear()
                    GMMapView1.Refresh()

                    objSmart.Locate(objPntGeom, GMMapView1.Dispatch, objLoc)

                    For I = 1 To objLoc.Count
                        GMMapView1.MapViewSelectedObjects.Add(objLoc.Item(I))
                    Next I

                    GMMapView1.FitSelectedObjects()

            End Select

        ElseIf e.button = 2 Then
            selPntNum = 0
            MapFunct = 0
            GMMapView1.MousePointer = MapviewLib.CursorTypeConstants.gmmvctNWArrow
            ToolStripStatusLabel1.Text = ""
        End If

        GMMapView1.Refresh(True)
        Exit Sub

ErrorHandler:
        MsgBox(Err.Description)
        e.mapviewDispatch.EndDynamic()

    End Sub

    Private Sub EventControl1_MouseMoveEvent(ByVal sender As System.Object, ByVal e As AxGMEventControlLib._DGMEventControlEvents_MouseMoveEvent) Handles EventControl1.MouseMoveEvent
        'Zoom pan si ha seleccionat un punt
        If MapFunct = 3 And selPntNum = 1 Then
            GMMapView1.Pan(e.worldX - pntX, e.worldY - pntY, e.worldZ - pntZ)
            GMMapView1.Refresh(True)
        End If

    End Sub
    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Zoom in
        GMMapView1.Zoom(False, True, 1, 1, 1, True)
        GMMapView1.Refresh(True)
    End Sub
    Private Sub btnZoomSElect_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomSElect.Click
        'Zoom a element(s) seleccionat(s)
        MapFunct = 4
        ToolStripStatusLabel1.Text = "Selecciona Element(s)"
        GMMapView1.MousePointer = MapviewLib.CursorTypeConstants.gmmvctCrossHairZeroTolerance
    End Sub
    Private Sub btnZoomPan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomPan.Click
        'Zoom pan (moure)
        MapFunct = 3
        ToolStripStatusLabel1.Text = "Seleciona un punt i mou el ratol. Bot dret per a acabar."
        GMMapView1.MousePointer = MapviewLib.CursorTypeConstants.gmmvctPan
    End Sub
    Private Sub btnZoonOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoonOut.Click
        'Zoom out
        GMMapView1.Zoom(True, True, 1, 1, 1, True)
        GMMapView1.Refresh(True)
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRefrecar.Click
        'Borrem els simbols
        If objGeomEditFletxa.GeometryCount > 0 Then objGeomEditFletxa.RemoveAllGeometries()
        If objGeomEditFletxa2.GeometryCount > 0 Then objGeomEditFletxa2.RemoveAllGeometries()
        If objGeomEditObra.GeometryCount > 0 Then objGeomEditObra.RemoveAllGeometries()
        GMMapView1.Refresh()
    End Sub
    Private Sub btnZommAnterior_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZommAnterior.Click
        'zoom anterior
        GMMapView1.PreviousView()
        GMMapView1.Refresh(True)
    End Sub
    Private Sub btnZoomExtend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnZoomExtend.Click
        'zoom tot
        GMMapView1.Fit()
        GMMapView1.Refresh(True)
    End Sub
    Private Sub ZoomVentana_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZoomVentana.Click
        MapFunct = 1
        lblStatus.Text = "Tria el primer punt"
        Me.Refresh()
        GMMapView1.MousePointer = MapviewLib.CursorTypeConstants.gmmvctCrossHair
    End Sub
    Private Sub cmbTaulaAmplada_SelectedIndexChanged_1(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If cmbArxiuCarrer.Text.Contains("\") Then 'Si l'arxiu cont la ruta el carreguem
            Funcions.OmplirCmbColumnes(cmbArxiuCarrer.Text, cmbTaulaAmplada.Text, cmbCampsAmplada)
            Funcions.OmplirCmbColumnes(cmbArxiuCarrer.Text, cmbTaulaAmplada.Text, cmbCampsSentit)
        Else
            Funcions.OmplirCmbColumnes(txtCarpeta.Text & cmbArxiuCarrer.Text, cmbTaulaAmplada.Text, cmbCampsAmplada)
            Funcions.OmplirCmbColumnes(cmbArxiuCarrer.Text, cmbTaulaAmplada.Text, cmbCampsSentit)
        End If
    End Sub
    Private Sub Button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Mostrem el cuadre de dialeg per a selleccionar l'arxiu de configuraci
        OpenFileDialog1.FileName = "Tria l'arxiu de simbologia:"
        OpenFileDialog1.Filter = "Fitxer de Simbologia|*.fsm| tots els arxius|*.*"
        If (OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK) Then
            txtSimbologia.Text = OpenFileDialog1.FileName
            objConfig.objGeoWorkspace = OpenFileDialog1.FileName
        Else
            txtSimbologia.Text = ""
        End If
    End Sub
    Private Sub btnBus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBus.Click
        'Dibuixem les fletxes
        Dim objstyleServicePunts As New PView.StyleService
        Dim objGSS As New PClient.GeometryStorageServiceClass
        Dim pntDesp As PBasic.point = New PBasic.point
        Dim rsr As GDO.GRecordset
        Dim rutabd As String
        Dim objDB As GDO.GDatabase
        ' Create Oriented Point object
        objOrntPnt = CreateObject("GeoMedia.OrientedPointGeometry")
        ' Define Style object for Oriented Points
        objstyleServicePunts.GetStyle("Symbol Style", objstylePunts)
        With objstylePunts
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySymbolRendererName).Value = "FSM"
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertyOverrideColor).Value = RGB(btnSimbolFetxa.BackColor.R, btnSimbolFetxa.BackColor.G, btnSimbolFetxa.BackColor.B)
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySize).Value = txtMidaFletxa.Text
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySource).Value = txtSimbologia.Text & ";" & txtNomFletxa.Text '";Direction"
        End With
        objDB = CreateObject("Access.GDatabase")
        rutabd = txtRutaSortida.Text & txtArxiuSortida.Text & ".mdb"
        Try
            objDB.OpenDatabase(rutabd, , True)
        Catch
        End Try
        Dim sql As String
        sql = "select * from Pol_Carrers WHERE SENTIT <> 0"
        rsr = objDB.OpenRecordset(sql, GDO.GConstants.gdbOpenDynaset)
        'Recorrem la taula
        While Not rsr.EOF
            objGSS.GetGeometry(rsr.GFields("Centroide"), objOrntPnt)
            objGeomEditFletxa.AppendGeometry(objOrntPnt, objstylePunts)
            rsr.MoveNext()
        End While
        GMMapView1.Refresh()
        FletxaDoble()
    End Sub
    Private Sub FletxaDoble()
        Dim objstyleServicePunts As New PView.StyleService
        Dim objGSS As New PClient.GeometryStorageServiceClass
        Dim pntDesp As PBasic.point = New PBasic.point
        Dim rsr As GDO.GRecordset
        Dim rutabd As String
        Dim objDB As GDO.GDatabase
        ' Create Oriented Point object
        objOrntPnt = CreateObject("GeoMedia.OrientedPointGeometry")
        ' Define Style object for Oriented Points
        objstyleServicePunts.GetStyle("Symbol Style", objstylePunts)
        With objstylePunts
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySymbolRendererName).Value = "FSM"
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertyOverrideColor).Value = RGB(btnsimbolFletxaDoble.BackColor.R, btnsimbolFletxaDoble.BackColor.G, btnsimbolFletxaDoble.BackColor.B) 'True
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySize).Value = txtMidaFletxaDoble.Text
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySource).Value = txtSimbologia.Text & ";" & txtNomFletxaDoble.Text ' ";2_Fletxes"
        End With
        objDB = CreateObject("Access.GDatabase")
        rutabd = txtRutaSortida.Text & txtArxiuSortida.Text & ".mdb"
        Try
            objDB.OpenDatabase(rutabd, , True)
        Catch
        End Try
        Dim sql As String
        sql = "select * from Pol_Carrers WHERE SENTIT = 0" 'triem les de doble sentit
        rsr = objDB.OpenRecordset(sql, GDO.GConstants.gdbOpenDynaset)
        'Recorrem la taula
        While Not rsr.EOF
            objGSS.GetGeometry(rsr.GFields("Centroide"), objOrntPnt)
            objGeomEditFletxa2.AppendGeometry(objOrntPnt, objstylePunts)
            rsr.MoveNext()
        End While
        GMMapView1.Refresh()
    End Sub
    Private Sub PeatonalContorn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PeatonalContorn.Click
        ColorDialog1.ShowDialog()
        PeatonalContorn.BackColor = ColorDialog1.Color
    End Sub
    Private Sub InteriorPeatonal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InteriorPeatonal.Click
        ColorDialog1.ShowDialog()
        InteriorPeatonal.BackColor = ColorDialog1.Color
    End Sub
    Private Sub contornBici_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles contornBici.Click
        ColorDialog1.ShowDialog()
        contornBici.BackColor = ColorDialog1.Color
    End Sub
    Private Sub interiorBici_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles interiorBici.Click
        ColorDialog1.ShowDialog()
        interiorBici.BackColor = ColorDialog1.Color
    End Sub
    Private Sub interiorCarrils_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles interiorCarrils.Click
        ColorDialog1.ShowDialog()
        interiorCarrils.BackColor = ColorDialog1.Color
    End Sub
    Private Sub contornCarrils_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles contornCarrils.Click
        ColorDialog1.ShowDialog()
        contornCarrils.BackColor = ColorDialog1.Color
    End Sub
    Private Sub interiorCarrers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles interiorCarrers.Click
        ColorDialog1.ShowDialog()
        interiorCarrers.BackColor = ColorDialog1.Color
    End Sub
    Private Sub contornCarrers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles contornCarrers.Click
        ColorDialog1.ShowDialog()
        contornCarrers.BackColor = ColorDialog1.Color
    End Sub
    Private Sub sepCarrils_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles sepCarrils.Click
        ColorDialog1.ShowDialog()
        sepCarrils.BackColor = ColorDialog1.Color
    End Sub
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSigTaules.Click
        TabControl1.SelectedIndex = 3
    End Sub
    Private Sub btnSig3_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSig3.Click
        'Guardem les dades del formulari a la classe
        With objConfig
            .smSeparacioCarril.style = cmbLineStyle.Text
            .smSimbolBici.Arxiu = txtNomBici.Text
            .smSimbolBici.Mida = txtMidaBici.Text
            .smSimbolBici.colorSimbol = btnSimbolBici.BackColor
            .smSimbolPeatonal.Arxiu = txtNomPeatonal.Text
            .smSimbolPeatonal.Mida = txtMidaPeatonal.Text
            .smSimbolPeatonal.colorSimbol = btnSimbolPeatonal.BackColor
            .smSimbolFletxaDoble.Arxiu = txtNomFletxaDoble.Text
            .smSimbolFletxaDoble.Mida = txtMidaFletxaDoble.Text
            .smSimbolFletxaDoble.colorSimbol = btnsimbolFletxaDoble.BackColor
            .smSimbolFletxa.Arxiu = txtNomFletxa.Text
            .smSimbolFletxa.Mida = txtMidaFletxa.Text
            .smSimbolFletxa.colorSimbol = btnSimbolFetxa.BackColor
            .smSimbolPdV.Arxiu = txtNomPdV.Text
            .smSimbolPdV.Mida = txtMidaPdv.Text
            .smSimbolPdV.colorSimbol = btncolorPasVianants.BackColor
            .smSimbolObres.Arxiu = txtNomObres.Text
            .smSimbolObres.Mida = txtMidaObres.Text
            .smSimbolObres.colorSimbol = btnsimbolObres.BackColor

        End With




        Me.Cursor = Cursors.WaitCursor
        'Create Geometry Edit Service object
        objGeomEditFletxa = CreateObject("GeoMedia.GeometryEditService")
        objGeomEditFletxa.MapView = GMMapView1.Dispatch
        objGeomEditObra = CreateObject("GeoMedia.GeometryEditService")
        objGeomEditObra.MapView = GMMapView1.Dispatch
        objGeomEditFletxa2 = CreateObject("GeoMedia.GeometryEditService")
        objGeomEditFletxa2.MapView = GMMapView1.Dispatch
        'Definim les caracteristiques del eventcontrol, per a fer els zooms
        objEvSrv = CreateObject("Geomedia.EventServer")
        MapFunct = 0

        ' Set MapView parameters
        With GMMapView1
            .CoordSystemsMgr = New PCSS.CoordSystemsMgr
            .Legend = New PView.Legend
            .LocateTolerance = 7
            .BackgroundColor = RGB(255, 255, 255)
            If .HighlightColor <> RGB(0, 180, 180) Then _
            .HighlightedObjects.SetDisplayColor(RGB(0, 255, 255))
            If .SelectColor <> RGB(180, 0, 180) Then _
            .MapViewSelectedObjects.SetDisplayColor(RGB(180, 0, 180))
            .MousePointer = MapviewLib.CursorTypeConstants.gmmvctNWArrow
            .PreserveMapScaleWhenResizing = True
            .SelectBehavior = MapviewLib.MapSelectBehaviorConstants.gmwHighlightOnly
            .SelectBehaviorConditions = MapviewLib.MapSelectBehaviorConstants.gmwAnyWindowActive
            .SelectBehaviorZoomFactor = 1
            .ZoomFactor = 1.5
        End With
        GMLegendView1.Top = 50
        GMLegendView1.Legend = GMMapView1.Legend
        'Ens connectem a la base de dades
        With objConn
            .Location = txtRutaSortida.Text & txtArxiuSortida.Text & ".mdb"
            .Description = "PFC SIG UOC"
            .Mode = PClient.ConnectionConstants.gmcModeReadOnly
            .Type = "Access.GDatabase"
            .Name = "Connect1"
            .Connect()
        End With
        objConn.CreateOriginatingPipe(objOP)
        With objOP
            .GeometryFieldName = "Geometry"
            .Table = "Separacio_Carrils"
        End With
        objRS = objOP.OutputRecordset
        'Creem la llegenda
        objLE = CreateObject("Geomedia.LegendEntry")
        'Els estils de la capa separacio carrils
        objStyleService = New PView.StyleService
        objStyleService.GetStyle("Simple Line Style", objstyle)
        With objstyle
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 1
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(sepCarrils.BackColor.R, sepCarrils.BackColor.G, sepCarrils.BackColor.B)
            Select Case cmbLineStyle.Text
                Case "Dotted"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeDotted
                Case "LongDashDoubleDot"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeLongDashDoubleDot
                Case "LongDashDoubleMediumDash"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeLongDashDoubleMediumDash
                Case "LongDashed"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeLongDashed
                Case "DashMediumDash"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeLongDashMediumDash
                Case "LongDashSingleDot"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeLongDashSingleDot
                Case "LongDashTripleDot"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeLongDashTripleDot
                Case "MediumDashDot"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeMediumDashDot
                Case "MediumDashDoubleDot"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeMediumDashDoubleDot
                Case "Solid"
                    .StyleProperties(PView.StylePropertyConstants.gmgroPropertySequenceType).Value = PView.StyleSequenceTypeConstants.gmgroSequenceTypeSolid
            End Select
        End With
        Dim objproperty As New PClient.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = "Separacio Carrils"
        ' Posem les caracteristiques de la llegenda
        With objLE
            .GeometryFieldName = "Geometry"
            .InputRecordset = objRS
            .Style = objstyle
            .PropertySet.Append(objproperty)
        End With

        GMMapView1.Legend.LegendEntries.Append(objLE)
        objLE.LoadData()

        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        '   AFEGIM UNA ALTRA CAPA CENTRE CARRILS PEATONALS                        '
        '
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        objConn.CreateOriginatingPipe(objOP)
        With objOP
            .GeometryFieldName = "Centroide"
            .Table = "Carrils_Peatonals"
        End With
        objRS = Nothing
        objRS = objOP.OutputRecordset
        objLE = CreateObject("Geomedia.LegendEntry")

        'l'estil de les capes
        objStyleService = New PView.StyleService
        ' Define Style object for Oriented Points
        objStyleService.GetStyle("Symbol Style", objstyle)
        With objstyle
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySymbolRendererName).Value = "FSM"
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertyOverrideColor).Value = RGB(btnSimbolPeatonal.BackColor.R, btnSimbolPeatonal.BackColor.G, btnSimbolPeatonal.BackColor.B)
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySize).Value = txtMidaPeatonal.Text
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySource).Value = txtSimbologia.Text & ";" & txtNomPeatonal.Text '";peatonal"
        End With
        'Llegenda
        objproperty = New PClient.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = "Simbols Peatonals"
        With objLE
            .GeometryFieldName = "Centroide"
            .InputRecordset = objRS
            .Style = objstyle
            .PropertySet.Append(objproperty)
        End With

        GMMapView1.Legend.LegendEntries.Append(objLE)
        objLE.LoadData()
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        '   AFEGIM UNA ALTRA CAPA CARRILS BICI                                  '
        '
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        objConn.CreateOriginatingPipe(objOP)
        With objOP
            .GeometryFieldName = "Centroide"
            .Table = "Carrils_Bici"
        End With

        objRS = Nothing
        objRS = objOP.OutputRecordset
        objLE = CreateObject("Geomedia.LegendEntry")

        'l'estil de les capes
        objStyleService = New PView.StyleService
        ' Define Style object for Oriented Points
        objStyleService.GetStyle("Symbol Style", objstyle)
        With objstyle
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySymbolRendererName).Value = "FSM"
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertyOverrideColor).Value = RGB(btnSimbolBici.BackColor.R, btnSimbolBici.BackColor.G, btnSimbolBici.BackColor.B) 'True
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySize).Value = txtMidaBici.Text
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySource).Value = txtSimbologia.Text & ";" & txtNomBici.Text '";02SBIK01"
        End With
        'Llegenda
        objproperty = New PClient.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = "Simbols Bici"
        With objLE
            .GeometryFieldName = "Centroide"
            .InputRecordset = objRS
            .Style = objstyle
            .PropertySet.Append(objproperty)
        End With

        GMMapView1.Legend.LegendEntries.Append(objLE)
        objLE.LoadData()
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        '   AFEGIM UNA ALTRA PASOS VIANANTS                                  '
        '
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        objConn.CreateOriginatingPipe(objOP)
        With objOP
            .GeometryFieldName = "Geometry"
            .Table = "Nodes"
        End With

        objRS = Nothing
        objRS = objOP.OutputRecordset
        objLE = CreateObject("Geomedia.LegendEntry")

        'l'estil de les capes
        objStyleService = New PView.StyleService
        ' Define Style object for Oriented Points
        objStyleService.GetStyle("Symbol Style", objstyle)
        With objstyle
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySymbolRendererName).Value = "FSM"
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertyOverrideColor).Value = RGB(btncolorPasVianants.BackColor.R, btncolorPasVianants.BackColor.G, btncolorPasVianants.BackColor.B) 'True
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySize).Value = txtMidaPdv.Text
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySource).Value = txtSimbologia.Text & ";" & txtNomPdV.Text '";Pedestrian Crossing"
        End With
        'Llegenda
        objproperty = New PClient.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = "Pasos de Vianants"
        With objLE
            .GeometryFieldName = "Geometry"
            .InputRecordset = objRS
            .Style = objstyle
            .PropertySet.Append(objproperty)
        End With

        GMMapView1.Legend.LegendEntries.Append(objLE)
        objLE.LoadData()
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        '   AFEGIM UNA ALTRA CAPA  PER ALS CARRILS BICI         '
        '
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        'connectem amb la base de dades
        objConn.CreateOriginatingPipe(objOP)
        With objOP
            .GeometryFieldName = "Geometry"
            .Table = "Carrils_Bici"
        End With

        objRS = Nothing
        objRS = objOP.OutputRecordset
        objLE = CreateObject("Geomedia.LegendEntry")

        'l'estil de les capes

        objStyleService.GetStyle("Area Style", objstyle)
        objstyle.StyleDefinitions(0).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 1
        objstyle.StyleDefinitions(0).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(contornBici.BackColor.R, contornBici.BackColor.G, contornBici.BackColor.B) '
        objstyle.StyleDefinitions(1).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(interiorBici.BackColor.R, interiorBici.BackColor.G, interiorBici.BackColor.B)

        'Llegenda
        objproperty = New PClient.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = "Carrils Bici"
        With objLE
            .GeometryFieldName = "Geometry"
            .InputRecordset = objRS
            .Style = objstyle
            .PropertySet.Append(objproperty)
        End With

        GMMapView1.Legend.LegendEntries.Append(objLE)
        objLE.LoadData()

        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        '                                                                            '        
        '   AFEGIM UNA ALTRA CAPA PER ALS CARRILS PEATONALS                          '
        '                                                                            '
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        'connectem amb la base de dades
        objConn.CreateOriginatingPipe(objOP)
        With objOP
            .GeometryFieldName = "Geometry"
            .Table = "Carrils_Peatonals"
        End With

        objRS = Nothing
        objRS = objOP.OutputRecordset
        objLE = CreateObject("Geomedia.LegendEntry")

        'l'estil de les capes
        objStyleService = New PView.StyleService
        objStyleService.GetStyle("Area Style", objstyle)
        objstyle.StyleDefinitions(0).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 1 ' Gruix
        objstyle.StyleDefinitions(0).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(PeatonalContorn.BackColor.R, PeatonalContorn.BackColor.G, PeatonalContorn.BackColor.B) 'Contorn
        objstyle.StyleDefinitions(1).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(InteriorPeatonal.BackColor.R, InteriorPeatonal.BackColor.G, InteriorPeatonal.BackColor.B) 'RGB(250, 200, 200) 'Repl

        'Llegenda
        objproperty = New PClient.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = "Carrils Peatonals"
        With objLE
            .GeometryFieldName = "Geometry"
            .InputRecordset = objRS
            .Style = objstyle
            .PropertySet.Append(objproperty)
        End With

        GMMapView1.Legend.LegendEntries.Append(objLE)
        objLE.LoadData()

        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        '   AFEGIM UNA ALTRA CAPA  PER ALS POlIGONS DELS CARRILS         '
        '
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        'connectem amb la base de dades
        objConn.CreateOriginatingPipe(objOP)
        With objOP
            .GeometryFieldName = "Geometry"
            .Table = "Carrils"
        End With

        objRS = Nothing
        objRS = objOP.OutputRecordset
        objLE = CreateObject("Geomedia.LegendEntry")

        'l'estil de les capes
        objStyleService = New PView.StyleService
        objStyleService.GetStyle("Area Style", objstyle)
        objstyle.StyleDefinitions(0).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 1 ' Gruix
        objstyle.StyleDefinitions(0).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(contornCarrils.BackColor.R, contornCarrils.BackColor.G, contornCarrils.BackColor.B) 'Contorn
        objstyle.StyleDefinitions(1).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(interiorCarrils.BackColor.R, interiorCarrils.BackColor.G, interiorCarrils.BackColor.B) 'Repl

        'Llegenda
        objproperty = New PClient.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = "Carrils"
        With objLE
            .GeometryFieldName = "Geometry"
            .InputRecordset = objRS
            .Style = objstyle
            .PropertySet.Append(objproperty)
        End With

        GMMapView1.Legend.LegendEntries.Append(objLE)
        objLE.LoadData()
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

        '   AFEGIM UNA ALTRA CAPA AMB ELS CARRERS        '
        '
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        'Fem un polgon amb l'ample total del carrer
        'connectem amb la base de dades
        objConn.CreateOriginatingPipe(objOP)
        With objOP
            .GeometryFieldName = "Geometry"
            .Table = "Pol_Carrers"
        End With

        objRS = Nothing
        objRS = objOP.OutputRecordset
        objLE = CreateObject("Geomedia.LegendEntry")

        'l'estil de les capes
        objStyleService = New PView.StyleService
        objStyleService.GetStyle("Area Style", objstyle)
        objstyle.StyleDefinitions(0).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 1 ' Gruix
        objstyle.StyleDefinitions(0).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(contornCarrers.BackColor.R, contornCarrers.BackColor.G, contornCarrers.BackColor.B) 'Contorn
        objstyle.StyleDefinitions(1).StyleDefinitions(0).StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(interiorCarrers.BackColor.R, interiorCarrers.BackColor.G, interiorCarrers.BackColor.B) 'Repl

        'Llegenda
        objproperty = New PClient.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = "Carrers"
        With objLE
            .GeometryFieldName = "Geometry"
            .InputRecordset = objRS
            .Style = objstyle
            .PropertySet.Append(objproperty)
        End With

        GMMapView1.Legend.LegendEntries.Append(objLE)
        objLE.LoadData()



        '''''''''''''''''''''''''''''''''''''''
        '''''''''''''''''''''''''''''''''''''''


        GMMapView1.Fit()
        GMMapView1.Refresh()
        btnSig3.Enabled = False
        'Me.Width = 1100
        'Me.Height = 550

        TabControl1.SelectedIndex = 4
        Me.WindowState = FormWindowState.Maximized
        Me.Cursor = Cursors.Default
        GMMapView1.Fit()
        GMMapView1.Refresh()

    End Sub
    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        'guardem la configuraci a l'arxiu
        With objConfig

            .smSeparacioCarril.style = cmbLineStyle.Text
            .smCarrilPeatonal.Interior = InteriorPeatonal.BackColor
            .smCarrilPeatonal.Contorn = PeatonalContorn.BackColor
            .smCarrilBici.Interior = interiorBici.BackColor
            .smCarrilBici.Contorn = contornBici.BackColor
            .smCarril.Interior = contornCarrils.BackColor
            .smCarril.Contorn = contornCarrils.BackColor
            .smCarrers.Interior = interiorCarrers.BackColor
            .smCarrers.Contorn = contornCarrers.BackColor
            .smSeparacioCarril.colorSimbol = sepCarrils.BackColor
            .smSeparacioCarril.style = cmbLineStyle.Text
            .smSimbolBici.Arxiu = txtNomBici.Text
            .smSimbolBici.Mida = txtMidaBici.Text
            .smSimbolBici.colorSimbol = btnSimbolBici.BackColor
            .smSimbolPeatonal.Arxiu = txtNomPeatonal.Text
            .smSimbolPeatonal.Mida = txtMidaPeatonal.Text
            .smSimbolPeatonal.colorSimbol = btnSimbolPeatonal.BackColor
            .smSimbolFletxaDoble.Arxiu = txtNomFletxaDoble.Text
            .smSimbolFletxaDoble.Mida = txtMidaFletxaDoble.Text
            .smSimbolFletxaDoble.colorSimbol = btnsimbolFletxaDoble.BackColor
            .smSimbolFletxa.Arxiu = txtNomFletxa.Text
            .smSimbolFletxa.Mida = txtMidaFletxa.Text
            .smSimbolFletxa.colorSimbol = btnSimbolFetxa.BackColor
            .smSimbolPdV.Arxiu = txtNomPdV.Text
            .smSimbolPdV.Mida = txtMidaPdv.Text
            .smSimbolPdV.colorSimbol = btncolorPasVianants.BackColor
            .smSimbolObres.Arxiu = txtNomObres.Text
            .smSimbolObres.Mida = txtMidaObres.Text
            .smSimbolObres.colorSimbol = btnsimbolObres.BackColor
        End With



        objConfig.fnDesarDades(txtRutaSortida.Text & txtArxiuSortida.Text & ".cnf")
    End Sub
    Private Sub Button4_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        TabControl1.SelectedIndex = 0
    End Sub
    Private Sub Button5_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        TabControl1.SelectedIndex = 1
    End Sub
    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        TabControl1.SelectedIndex = 2
    End Sub
    Public Sub New()

        ' Llamada necesaria para el Diseador de Windows Forms.
        InitializeComponent()

        ' Agregue cualquier inicializacin despus de la llamada a InitializeComponent().

    End Sub
    Private Sub btnSimbolBici_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSimbolBici.Click
        ColorDialog1.ShowDialog()
        btnSimbolBici.BackColor = ColorDialog1.Color
        objConfig.smSimbolBici.colorSimbol = btnSimbolBici.BackColor
    End Sub
    Private Sub btnSimbolPeatonal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSimbolPeatonal.Click
        ColorDialog1.ShowDialog()
        btnSimbolPeatonal.BackColor = ColorDialog1.Color
        objConfig.smSimbolPeatonal.colorSimbol = btnSimbolPeatonal.BackColor
    End Sub
    Private Sub btnSimbolFetxa_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSimbolFetxa.Click
        ColorDialog1.ShowDialog()
        btnSimbolFetxa.BackColor = ColorDialog1.Color
        objConfig.smSimbolFletxa.colorSimbol = btnSimbolFetxa.BackColor
    End Sub
    Private Sub txtMidaBici_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtMidaBici.TextChanged
        If Not IsNumeric(txtMidaBici.Text) Then
            txtMidaBici.Text = 350
            MsgBox("Nombre invalid")
        ElseIf CDbl(txtMidaBici.Text) < 1 Then
            txtMidaBici.Text = 350
            MsgBox("El valor ha de ser positiu")
        End If
    End Sub
    Private Sub txtMidaPeatonal_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtMidaPeatonal.TextChanged
        If Not IsNumeric(txtMidaPeatonal.Text) Then
            txtMidaPeatonal.Text = 350
            MsgBox("Nombre invalid")
        ElseIf CDbl(txtMidaPeatonal.Text) < 1 Then
            txtMidaPeatonal.Text = 350
            MsgBox("El valor ha de ser positiu")
        End If
    End Sub
    Private Sub txtMidaFletxa_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtMidaFletxa.TextChanged
        If Not IsNumeric(txtMidaFletxa.Text) Then
            txtMidaFletxa.Text = 350
            MsgBox("Nombre invalid")
        ElseIf CDbl(txtMidaFletxa.Text) < 1 Then
            txtMidaFletxa.Text = 350
            MsgBox("El valor ha de ser positiu")
        End If
    End Sub
    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        MapFunct = 2 'Definim l'estil del simbol d'obra i al fer click a la pantalla ens sortir el simbol dibuixat
        lblStatus.Text = "Tria on posar simbol, bot dret per a acabar"
        ' Definim l'estil
        objStyleServiceObra.GetStyle("Symbol Style", objstyleObra)
        With objstyleObra
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySymbolRendererName).Value = "FSM"
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertyOverrideColor).Value = RGB(objConfig.smSimbolObres.colorSimbol.R, objConfig.smSimbolObres.colorSimbol.G, objConfig.smSimbolObres.colorSimbol.B)
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySize).Value = txtMidaObres.Text
            .StyleProperties(PView.StylePropertyConstants.gmgroPropertySource).Value = txtSimbologia.Text & ";" & txtNomObres.Text '";b_eldelapala"
        End With
    End Sub
    Private Sub cmbArxiuCarrer_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbArxiuCarrer.SelectedIndexChanged
        If cmbArxiuCarrer.Text.Contains("\") Then 'Si l'arxiu cont la ruta el carreguem
            Funcions.OmplirCmbambTaules(cmbArxiuCarrer.Text, controlesTaula)
        Else
            Funcions.OmplirCmbambTaules(txtCarpeta.Text & cmbArxiuCarrer.Text, controlesTaula)
        End If
        objConfig.clCarrer.Taula = cmbArxiuCarrer.Text
    End Sub
    Private Sub txtCarpeta_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtCarpeta.TextChanged
        If (txtCarpeta.Text <> "Text Obligatori") Then
            'Omplim els combobox amb els arxius mdb
            Funcions.OmplirCmbArxius(txtCarpeta.Text, Controles)
            objConfig = New configuracio
            With objConfig
                .clCarrer.Ruta = txtCarpeta.Text
                .clSentit.Ruta = txtCarpeta.Text
                .clCarrils.Ruta = txtCarpeta.Text
                .clAmplada.Ruta = txtCarpeta.Text
                .clPeatonal.Ruta = txtCarpeta.Text
                .clBici.Ruta = txtCarpeta.Text
                .rutaDades = txtCarpeta.Text
            End With
        End If
    End Sub

    Private Sub cmbTaulaNodes_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbTaulaNodes.SelectedIndexChanged
        objConfig.clNodes.Taula = cmbTaulaNodes.Text
    End Sub
    Private Sub cmbTaulaCarrer_SelectedIndexChanged_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbTaulaCarrer.SelectedIndexChanged
        If cmbArxiuCarrer.Text.Contains("\") Then 'Si l'arxiu cont la ruta el carreguem
            Funcions.OmplircolCmbColumnes(cmbArxiuCarrer.Text, cmbTaulaCarrer.Text, controlesCamps)
        Else
            Funcions.OmplircolCmbColumnes(txtCarpeta.Text & cmbArxiuCarrer.Text, cmbTaulaCarrer.Text, controlesCamps)
        End If
    End Sub
    Private Sub cmbTaulaAmplada_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbTaulaAmplada.SelectedIndexChanged
        If cmbArxiuCarrer.Text.Contains("\") Then 'Si l'arxiu cont la ruta el carreguem
            Funcions.OmplirCmbColumnes(cmbArxiuCarrer.Text, cmbTaulaAmplada.Text, cmbCampsAmplada)
            Funcions.OmplirCmbColumnes(cmbArxiuCarrer.Text, cmbTaulaAmplada.Text, cmbCampsSentit)
        Else
            Funcions.OmplirCmbColumnes(txtCarpeta.Text & cmbArxiuCarrer.Text, cmbTaulaAmplada.Text, cmbCampsAmplada)
            Funcions.OmplirCmbColumnes(cmbArxiuCarrer.Text, cmbTaulaAmplada.Text, cmbCampsSentit)
        End If
    End Sub
    Private Sub btncolorPasVianants_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btncolorPasVianants.Click
        ColorDialog1.ShowDialog()
        btncolorPasVianants.BackColor = ColorDialog1.Color
        objConfig.smSimbolPdV.colorSimbol = btncolorPasVianants.BackColor
    End Sub
    Private Sub btnsimbolObres_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnsimbolObres.Click
        ColorDialog1.ShowDialog()
        btnsimbolObres.BackColor = ColorDialog1.Color
        objConfig.smSimbolObres.colorSimbol = btnsimbolObres.BackColor
    End Sub
    Private Sub txtMidaPdv_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtMidaPdv.TextChanged
        If Not IsNumeric(txtMidaPdv.Text) Then
            txtMidaPdv.Text = 350
            MsgBox("Nombre invalid")
        ElseIf CDbl(txtMidaPdv.Text) < 1 Then
            txtMidaPdv.Text = 350
            MsgBox("El valor ha de ser positiu")
        End If
    End Sub
    Private Sub txtMidaObres_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtMidaObres.TextChanged
        If Not IsNumeric(txtMidaObres.Text) Then
            txtMidaObres.Text = 350
            MsgBox("Nombre invalid")
        ElseIf CDbl(txtMidaObres.Text) < 1 Then
            txtMidaObres.Text = 350
            MsgBox("El valor ha de ser positiu")
        End If
    End Sub

    Private Sub txtMidaFletxaDoble_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtMidaFletxaDoble.TextChanged
        If Not IsNumeric(txtMidaFletxaDoble.Text) Then
            txtMidaFletxaDoble.Text = 350
            MsgBox("Nombre invalid")
        ElseIf CDbl(txtMidaFletxaDoble.Text) < 1 Then
            txtMidaFletxaDoble.Text = 350
            MsgBox("El valor ha de ser positiu")
        End If
    End Sub

    Private Sub btnsimbolFletxaDoble_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnsimbolFletxaDoble.Click
        ColorDialog1.ShowDialog()
        btnsimbolFletxaDoble.BackColor = ColorDialog1.Color
        objConfig.smSimbolFletxaDoble.colorSimbol = btnsimbolFletxaDoble.BackColor
    End Sub

    Private Sub cmbLineStyle_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbLineStyle.SelectedIndexChanged
        objConfig.smSeparacioCarril.style = cmbLineStyle.Text
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        Me.Close()
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        With GMLegendView1
            If .Visible Then
                .Visible = False
            Else
                .Visible = True
            End If
        End With

    End Sub

    Private Sub btnAfegirArxiu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAfegirArxiu.Click
        'Si la nostra taula no apareix al llistat del combobox l'afegim
        Funcions.AfegirNovaTaula(cmbArxiuCarrer, OpenFileDialog1)
    End Sub
End Class






































