Public Class taules

    Private Sub funcions_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Sub crearTaules()

        Dim objDB As GDO.GDatabase, objTbl As GDO.GTableDef
        Dim objFld As GDO.GField
        '***********************************  Fem la taula dels Carrers ************************************
        Try
            objDB = CreateObject("Access.GDatabase")

            ' Create database 
            'objDB.CreateDatabase("c:\temp\NewDB", GDO.GConstants.gdbLangGeneral)
            objDB.CreateDatabase("C:\Temp\" & Me.TextBox1.Text & ".mdb", GDO.GConstants.gdbLangGeneral)
        Catch
            MsgBox("Error al crear la base de dades", MsgBoxStyle.Exclamation, )
        End Try

        'Create table object 

        objTbl = objDB.CreateTableDef("Pol_Carrers")
        objTbl.Name = "Pol_Carrers"

        ' Create and define index on "ID" field 
        Dim objIdx As GDO.GIndex, objIdxFld As GDO.GField

        objIdx = objTbl.CreateIndex("IDidx")

        objIdxFld = objIdx.CreateField("ID1")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDidx"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With

        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing
        'Crerar un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With

        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crerar un camp numric Per al SENTIT
        objFld = objTbl.CreateField("SENTIT", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 1
            .Name = "SENTIT"
            .Required = False
        End With

        objTbl.GFields.Append(objFld)
        objFld = Nothing
        'Crerar un camp numric Per al SENTIT
        objFld = objTbl.CreateField("CARRILS", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 1
            .Name = "CARRILS"
            .Required = False
        End With

        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crear i afegir un camp de tipus nmero  per al tipus de carril PEATONAL
        objFld = objTbl.CreateField("PEATONAL", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 0
            .Name = "PEATONAL"
            .Required = False
        End With


        objTbl.GFields.Append(objFld)
        objFld = Nothing
        'Crear i afegir un camp de tipus nmero  per al tipus de carril BICI
        objFld = objTbl.CreateField("CBICI", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 0
            .Name = "CBICI"
            .Required = False
        End With


        objTbl.GFields.Append(objFld)
        objFld = Nothing




        'Crerar un camp numric Per a l'Amplada del carril
        objFld = objTbl.CreateField("AMPLADA", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 3
            .Name = "AMPLADA"
            .Required = False
        End With


        objTbl.GFields.Append(objFld)
        objFld = Nothing




        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("ID1", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Create, define, and append geometry field 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        objDB.GTableDefs.Append(objTbl)



        objTbl = Nothing

        ' *********************** Fem la taula de separadors de carrils ***************************************


        objTbl = objDB.CreateTableDef("Linia_Carrils")
        objTbl.Name = "Separacio_Carrils"

        ' Create and define index on "ID" field 

        objIdx = objTbl.CreateIndex("IDidx")

        objIdxFld = objIdx.CreateField("ID")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDidx"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With

        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing
        'Crerar un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With

        objTbl.GFields.Append(objFld)
        objFld = Nothing


        objFld = Nothing
        'Crerar un camp numric per al nombre de carrils
        objFld = objTbl.CreateField("CARRILS", GDO.GConstants.gdbInteger)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 1
            .Name = "CARRILS"
            .Required = True
        End With

        objTbl.GFields.Append(objFld)
        objFld = Nothing
        objFld = objTbl.CreateField("PEATONAL", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 0
            .Name = "PEATONAL"
            .Required = False
        End With


        objTbl.GFields.Append(objFld)
        objFld = Nothing
        'Crear i afegir un camp de tipus nmero  per al tipus de carril BICI
        objFld = objTbl.CreateField("CBICI", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 0
            .Name = "CBICI"
            .Required = False
        End With


        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Crerar un camp numric Per a l'Amplada del carril
        objFld = objTbl.CreateField("AMPLADA", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 3
            .Name = "AMPLADA"
            .Required = False
        End With


        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("ID", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Create, define, and append geometry field 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbLinear
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        objDB.GTableDefs.Append(objTbl)

        objTbl = Nothing

        ' *********************** Fem la taula dels carrils Bici ***************************************


        objTbl = objDB.CreateTableDef("Carrils_Bici")
        objTbl.Name = "Carrils_Bici"

        ' Create and define index on "ID" field 


        objIdx = objTbl.CreateIndex("IDBici")

        objIdxFld = objIdx.CreateField("IDB")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDBici"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With

        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing
        'Crerar un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With

        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("IDB", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels carrils 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Crerar un camp numric Per a l'Amplada del carril
        objFld = objTbl.CreateField("CentreX", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 3
            .Name = "CentreX"
            .Required = False
        End With


        objTbl.GFields.Append(objFld)
        objFld = Nothing


        'Crerar un camp numric Per a l'Amplada del carril
        objFld = objTbl.CreateField("CentreY", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .DefaultValue = 3
            .Name = "CentreY"
            .Required = False
        End With


        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels centroides 
        objFld = objTbl.CreateField("Centroide", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbLinear
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing



        objDB.GTableDefs.Append(objTbl)


        ' *********************** Fem la taula dels carrils Peatonals ***************************************


        objTbl = objDB.CreateTableDef("Carrils_Peatonals")
        objTbl.Name = "Carrils_Peatonals"

        ' Create and define index on "ID" field 


        objIdx = objTbl.CreateIndex("IDPeat")

        objIdxFld = objIdx.CreateField("IDP")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDPeaat"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With

        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing
        'Crerar un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With

        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("IDP", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels carrils 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        objDB.GTableDefs.Append(objTbl)




        ' *********************** Fem la taula dels carrils  ***************************************


        objTbl = objDB.CreateTableDef("Carrils")
        objTbl.Name = "Carrils"

        ' Create and define index on "ID" field 


        objIdx = objTbl.CreateIndex("IDCarr")

        objIdxFld = objIdx.CreateField("IDCar")
        objIdx.GFields.Append(objIdxFld)
        objIdxFld = Nothing

        With objIdx
            .Name = "IDCarr"
            .IgnoreNulls = False
            .Primary = True
            .Unique = True
        End With

        objTbl.GIndexes.Append(objIdx)
        objIdx = Nothing
        'Crerar un camp numric Per al IDTRAM
        objFld = objTbl.CreateField("IDTRAM", GDO.GConstants.gdbDouble)
        With objFld
            .Attributes = GDO.GConstants.gdbVariableField
            .Name = "IDTRAM"
            .Required = False
        End With

        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Crea un camp per al identificador(auto-incrementing ID field) 
        objFld = objTbl.CreateField("IDCar", GDO.GConstants.gdbLong)
        objFld.Attributes = GDO.GConstants.gdbAutoIncrField
        objTbl.GFields.Append(objFld)
        objFld = Nothing

        'Creem un camp per a la geometria dels carrils 
        objFld = objTbl.CreateField("Geometry", GDO.GConstants.gdbSpatial)
        With objFld
            .Type = GDO.GConstants.gdbSpatial
            .SubType = GDO.GConstants.gdbAnySpatial
            .Required = True

        End With
        objTbl.GFields.Append(objFld)
        objFld = Nothing




        objDB.GTableDefs.Append(objTbl)



        '    objTbl = Nothing
        ' Close database and release objects 


        objDB.Close()



    End Sub

    Private Sub AddCSSRow(ByVal objDB As GDO.GDatabase, ByVal strGUID As String)

        Dim objRS As GDO.GRecordset, NumberOfFields As Integer
        Dim AliasTableName As String, CoordSystemTableName As String
        Dim QueryString As String, I As Integer, objCS As Object
        Dim ArrayOfFields As Object

        objCS = CreateObject("CoordSystem")

        ' Get Metadata alias table 
        AliasTableName = objDB.GAliasTable

        ' Get coordinate system table name from alias table 
        QueryString = "SELECT TableName From " & AliasTableName
        QueryString = QueryString & " WHERE TableType = "
        QueryString = QueryString & "'GCoordSystemTable'"
        objRS = objDB.OpenRecordset(QueryString, GDO.GConstants.gdbOpenSnapshot)
        CoordSystemTableName = objRS.GFields.Item(0)
        objRS.Close()
        objRS = Nothing

        ' Get coordinate system table 
        objRS = objDB.OpenRecordset(CoordSystemTableName, GDO.GConstants.gdbOpenDynaset)

        ' Get number of fields expected in records in the 
        ' coordinate system table 
        NumberOfFields = objRS.GFields.Count

        ReDim ArrayOfFields(0 To NumberOfFields - 1)

        objRS.AddNew()
        objCS.FormatGCoordSystemTableRow(ArrayOfFields)

        For I = 0 To NumberOfFields - 1
            objRS.GFields(I).Value = ArrayOfFields(I)
        Next

        ' Update the table 
        objRS.Update()
        objRS.MoveFirst()
        strGUID = objRS.GFields("CSGUID").Value
        objRS = Nothing
        objCS = Nothing

    End Sub

    Sub CreateMeta()
        'Dim Conn As New gConnection, objMeta As New MetadataService
        'Dim objTableMeta As New TableProperty

        'With Conn
        '    .Location = "C:\Temp\NewDB.mdb"
        '    .Type = "Access.GDatabase"
        '    .Connect()
        'End With

        '' Create metadata for new table 
        'objMeta.Connection = Conn
        'objMeta.TableName = "NewTable"

        'With objTableMeta
        '    .Description = "New database table"
        '    .Name = "NewTable"
        '    .PrimaryGeometryFieldName = "Geometry"
        '    .GeometryType = 1
        'End With

        'objMeta.AddTableMetadata(objTableMeta)

        'objTableMeta = Nothing
        'objMeta = Nothing

    End Sub
    Function CalcularAngle(ByVal pnt1 As PBasic.point, ByVal pnt2 As PBasic.point) As Double
        Dim incX As Double
        Dim incY As Double

        incY = pnt2.Y - pnt1.Y
        incX = pnt2.X - pnt1.X


        If incX = 0 Then

            If incY > 0 Then
                CalcularAngle = Math.PI / 2
            Else
                CalcularAngle = -(Math.PI / 2)
            End If

        Else
            CalcularAngle = Math.Atan((pnt2.Y - pnt1.Y) / (pnt2.X - pnt1.X))
        End If
        'If incX < 0 Then

        '    CalcularAngle = CalcularAngle + Math.PI / 2

        'End If

        Return CalcularAngle
    End Function
    Function Paralela(ByVal Geomt As Object, ByVal Amplada As Double) As PBasic.PolygonGeometry
        Dim PntIni As New PBasic.point
        Dim pntFi As New PBasic.point
        Dim Angle As Double, incX As Double, incY As Double
        Dim pnt0 As New PBasic.point
        Dim pnt1 As New PBasic.point
        Dim pnt2 As New PBasic.point
        Dim pnt3 As New PBasic.point
        Dim Gpoly = New PBasic.PolygonGeometryClass
        Dim i As Integer


        pnt0.X = Geomt.Points(1).x
        pnt0.Y = Geomt.Points(1).y
        Gpoly.Points.Add(pnt0)

        For i = 1 To Geomt.Points.Count - 1

            'Part dreta
            PntIni.X = Geomt.Points(i).x
            PntIni.Y = Geomt.Points(i).y
            pntFi.X = Geomt.Points(i + 1).x
            pntFi.Y = Geomt.Points(i + 1).y

            'Crear Punts dels contorn a partir amplada,....

            'Calculem els increments
            incY = pntFi.Y - PntIni.Y
            incX = pntFi.X - PntIni.X

            ' Calculem l'angle
            Angle = CalcularAngle(pntFi, PntIni)


            'un cop tenim l'angle calculem els punts

            'x = x0 + d * sen(Angle)
            pnt1.X = PntIni.X + (Amplada * Math.Cos(Angle + (Math.PI / 2)))
            'y=y0 + d * cos (Angle)
            pnt1.Y = PntIni.Y + (Amplada * Math.Sin(Angle + (Math.PI / 2)))
            Gpoly.Points.Add(pnt1)
            txtX.Text = pnt1.X
            txtY.Text = pnt1.Y
        Next
        'Calculem els increments
        incY = Geomt.Points(Geomt.Points.Count).Y - Geomt.Points(Geomt.Points.Count - 1).Y
        incX = Geomt.Points(Geomt.Points.Count).x - Geomt.Points(Geomt.Points.Count - 1).x

        'Fem l'ltim punt:
        pnt1.X = pnt1.X + incX
        pnt1.Y = pnt1.Y + incY
        Gpoly.Points.Add(pnt1)
        txtX.Text = pnt1.X
        txtY.Text = pnt1.Y
        'Part esquerra
        'For i = 2 To 1 Step -1
        '    MsgBox("Repeticin Nro: " & i)
        'Next
        For i = (Geomt.points.Count - 1) To 1 Step -1


            PntIni.X = Geomt.Points(i).x
            PntIni.Y = Geomt.Points(i).y
            pntFi.X = Geomt.Points(i + 1).x
            pntFi.Y = Geomt.Points(i + 1).y

            'Calculem els increments
            incY = pntFi.Y - PntIni.Y
            incX = pntFi.X - PntIni.X

            ' Calculem l'angle
            Angle = CalcularAngle(pntFi, PntIni)


            'un cop tenim l'angle calculem els punts
            'x = x0 + d * sen(Angle)
            pnt2.X = pntFi.X + (Amplada * Math.Cos(Angle - (Math.PI / 2)))
            'y=y0 + d * cos (Angle)
            pnt2.Y = pntFi.Y + (Amplada * Math.Sin(Angle - (Math.PI / 2)))
            Gpoly.Points.Add(pnt2)
            txtX.Text = pnt2.X
            txtY.Text = pnt2.Y
        Next
        'Fem l'ltim punt:
        'Calculem els increments
        incY = Geomt.Points(2).Y - Geomt.Points(1).Y
        incX = Geomt.Points(2).x - Geomt.Points(1).x
        pnt2.X = pnt2.X - incX
        pnt2.Y = pnt2.Y - incY
        Gpoly.Points.Add(pnt2)
        txtX.Text = pnt2.X
        txtY.Text = pnt2.Y
        'tornem a posar el punt inicial
        Gpoly.Points.Add(pnt0)

        Return Gpoly
    End Function
    Sub crearPoligonsCarrers()
        Dim objGSS As New PClient.GeometryStorageServiceClass, rsr As GDO.GRecordset, rsw As GDO.GRecordset, rsAmplada As GDO.GRecordset
        Dim Geomt As Object, pnt As New PBasic.point, pntInit As New PBasic.point
        Dim pntFi As New PBasic.point
        Dim cnk As Object, rutabd As String, sql As String, rutabd2 As String
        Dim Gpoly As PBasic.PolygonGeometryClass, GPolyLine As PBasic.PolylineGeometry
        Dim leftOffset As New PBasic.PolylineGeometry, rightOffset As New PBasic.PolylineGeometry
        Dim auxBol As Boolean, i As Integer


        Dim objDB As GDO.GDatabase
        Dim objDB2 As GDO.GDatabase

        objDB = CreateObject("Access.GDatabase")
        objDB2 = CreateObject("Access.GDatabase")
        rutabd = "C:\UOC\SIG\dades complementaries\Exemples1\Exemples1.mdb"
        rutabd2 = "C:\Temp\" & Me.TextBox1.Text & ".mdb"

        Try

            objDB.OpenDatabase("C:\UOC\SIG\dades complementaries\Exemples1\Exemples1.mdb", , True)
            objDB2.OpenDatabase("C:\Temp\" & Me.TextBox1.Text & ".mdb")

        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd = (InputBox("Ruta de la base de dades: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd)
        End Try
        'Recompte del nombre de nodes
        sql = "select * from TRAMS"
        rsr = objDB.OpenRecordset("select * from TRAMS", GDO.GConstants.gdbOpenDynaset)
        rsw = objDB2.OpenRecordset("select * from Pol_Carrers", GDO.GConstants.gdbOpenDynaset)

        Dim j As Integer
        j = 0
        lblProgres.Text = "Omplint taula Poligons carrers"

        'Recorrem la taula
        While Not rsr.EOF
            With ProgressBar1
                .Maximum = rsr.RecordCount()
                .Minimum = 0

            End With
            j = j + 1
            objGSS.GetGeometry(rsr.GFields("Geometry"), Geomt)
            If Geomt.Type = "PolylineGeometry" Then

                rsAmplada = objDB.OpenRecordset("select * from CARRILS Where IDTRAM=" & rsr.GFields("IDTRAM").Value, GDO.GConstants.gdbOpenDynaset)

                'Mirem el nombre de carrils


                pntInit.X = Geomt.Points(1).x
                pntInit.Y = Geomt.Points(1).y
                pntFi.X = Geomt.Points(2).x
                pntFi.Y = Geomt.Points(2).y


                Gpoly = New PBasic.PolygonGeometryClass
                GPolyLine = New PBasic.PolylineGeometry
                '******************************************************************************************************************

                '******************************************************************************************************************
                'Si no hi ha info de l'amplada posem 3
                Dim Ample As Double

                Try

                    Ample = rsr.GFields("CARRILS").Value * rsAmplada.GFields(3).Value
                Catch
                    'Si no hi ha informacio de l'amplada possem 3
                    Ample = rsr.GFields("CARRILS").Value * 3
                End Try

                'Fem la paralela    
                'costat dret
                rightOffset = New PBasic.PolylineGeometry
                leftOffset = New PBasic.PolylineGeometry
                auxBol = Paralela1(Geomt, Ample / 2, rightOffset, leftOffset)


                'For i = 1 To rightOffset.Points.Count

                '    Gpoly.Points.Add(rightOffset.Points.Item(i))
                'Next
                '' costat esquerre

                ''auxBol = Paralela1(Geomt, Ample, rightOffset, leftOffset)


                'For i = leftOffset.Points.Count To 1 Step -1

                '    Gpoly.Points.Add(leftOffset.Points.Item(i))
                'Next
                ''Posem el darrer al principi
                'Gpoly.Points.Add(Gpoly.Points.Item(1))
                Gpoly = crearPoligon(rightOffset, leftOffset)

                rsw.AddNew()
                objGSS.GeometryToStorage(Gpoly, cnk)
                rsw.GFields("ID1").Value = j


                Try

                    rsw.GFields("AMPLADA").Value = rsAmplada.GFields(3).Value
                Catch
                    'Si no hi ha informacio de l'amplada possem 3
                    rsw.GFields("AMPLADA").Value = 3
                End Try

                rsw.GFields("IDTRAM").Value = rsr.GFields("IDTRAM").Value
                'TIPUS
                rsw.GFields("PEATONAL").Value = rsr.GFields("PEATONAL").Value
                rsw.GFields("CARRILS").Value = rsr.GFields("CARRILS").Value
                rsw.GFields("CBICI").Value = rsr.GFields("CBICI").Value
                rsw.GFields("SENTIT").Value = rsr.GFields("SENTIT").Value
                rsw.GFields("Geometry").Value = cnk
                rsw.Update()

                Gpoly = Nothing
                Geomt = New Object

            End If
            rsr.MoveNext()
            ProgressBar1.Value = j
            Me.Refresh()
        End While
        objGSS = Nothing
        rsr = Nothing
        rsw = Nothing
        'rsr.Close()
        'rsw.Close()
        objDB.Close()
        objDB2.Close()
        txtX.Text = "TAULA PLENA"
        lblProgres.Text = "Taula  Poligons Creada"


    End Sub
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        'Dim objConn As PClient.Connection
        'Dim objOP As PClient.OriginatingPipe
        'Dim objCDTP As PPipe.ConflictDetectionPipe
        'Dim objUOM As PCSS.UnitsOfMeasure
        'Dim objBP As PPipe.BufferPipe
        'Dim objPK As PDBPipe.SortKey
        'objConn = New PClient.Connection
        'objConn.Location = "C:\Temp\" & TextBox1.Text & ".mdb"
        'objConn.Connect()

        '' Create and display recordset of Cities
        'objConn.CreateOriginatingPipe(objOP)
        'objOP.Table = "Pol_Carrils"

        'objBP = New PPipe.BufferPipe
        'objBP.InputRecordset = objOP.OutputRecordset
        'objBP.InputGeometryFieldName = "Geometry"
        'objBP.OutputGeometryFieldName = "BufferGeometry"
        'objBP.DistanceType = PPipe.GMBufferZoneDistanceConstants.gmbzConstantDistance
        'objBP.InputDistance = "11"
        'objUOM = New PCSS.UnitsOfMeasure
        'objBP.InputDistanceUnit = objUOM.GetUnitID(PCSS.UnitTypeConstants.igUnitDistance, "mi")

        ''Set Conflict Detection Pipe parameters
        'objCDTP = New PPipe.ConflictDetectionPipe
        'With objCDTP
        '    .InputRecordset = objBP.OutputRecordset
        '    .InputGeometryFieldName = objBP.OutputGeometryFieldName
        '    objPK = New PDBPipe.SortKey
        '    objPK.SortFieldName = "POP"
        '    objPK.SortAscendingFlag = False
        '    .PriorityKeys.Append(objPK)
        '    .OutputConflictFieldName = "Conflict"
        '    '  AddRLE(.OutputRecordset, RGB(0, 255, 0), .InputGeometryFieldName, .OutputConflictFieldName + "=0")
        '    '  AddRLE(.OutputRecordset, RGB(255, 0, 0), .InputGeometryFieldName, .OutputConflictFieldName + "<>0")
        'End With

        ''GMMapView1.Fit()
        ''GMMapView1.Refresh(True)

    End Sub
    Private Sub crearEixosCarrils()
        '**********************    Fem la taula de carrils  ***************************
        Dim objGSS As New PClient.GeometryStorageServiceClass, rsr As GDO.GRecordset, rsw As GDO.GRecordset, rsAmplada As GDO.GRecordset
        Dim pnt As New PBasic.point, pntInit As New PBasic.point
        Dim pntFi As New PBasic.point
        Dim cnk As Object
        Dim Ample As Double, Linia As New PBasic.PolylineGeometry
        Dim Geomt As Object, nCarrils As Integer, Contador As Integer, IdTram As Integer
        Dim objDB As GDO.GDatabase
        Dim objDB2 As GDO.GDatabase
        objDB = CreateObject("Access.GDatabase")
        objDB2 = CreateObject("Access.GDatabase")

        Dim leftOffset As New PBasic.PolylineGeometry, rightOffset As New PBasic.PolylineGeometry
        Dim auxBol As Boolean

        Try

            objDB.OpenDatabase("C:\UOC\SIG\dades complementaries\Exemples1\Exemples1.mdb", , True) 'noms lectura
            objDB2.OpenDatabase("C:\Temp\" & Me.TextBox1.Text & ".mdb")

        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            MsgBox("no s'ha pogut obri la bd, mira si ja existeix")
        End Try
        'Seleccionem les dades

        rsr = objDB.OpenRecordset("select * from TRAMS", GDO.GConstants.gdbOpenDynaset)
        rsw = objDB2.OpenRecordset("select * from Separacio_Carrils", GDO.GConstants.gdbOpenDynaset)
        Dim l As Integer
        Dim j As Integer
        j = 0
        l = 0
        lblProgres.Text = "Omplint Taula Separacio carrils"
        ProgressBar1.Value = 0
        'Recorrem la taula
        While Not rsr.EOF
            With ProgressBar1
                .Maximum = rsr.RecordCount()
                .Minimum = 0


            End With

            objGSS.GetGeometry(rsr.GFields("Geometry"), Geomt)

            rsAmplada = objDB.OpenRecordset("select * from CARRILS Where IDTRAM=" & rsr.GFields("IDTRAM").Value, GDO.GConstants.gdbOpenDynaset)



            'Busquem l'amplada dels carrils

            Try

                Ample = rsAmplada.GFields(3).Value
            Catch
                'Si no hi ha informacio de l'amplada possem 3
                Ample = 3
            End Try



            nCarrils = rsr.GFields("CARRILS").Value

            'Si el nombre de carrils es parell:
            nCarrils = rsr.GFields("CARRILS").Value

            If nCarrils > 1 Then ' Si noms hi ha un carril no cal fer res

                IdTram = rsr.GFields("IDTRAM").Value
                If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                    'Si el nombre de carrils es parell:
                    'Hem de posar una lnia a l'eix del carrer
                    'Omplim la taula
                    With rsw
                        .AddNew()
                        .GFields("IDTRAM").Value = IdTram
                        .GFields("CARRILS").Value = nCarrils
                        .GFields("AMPLADA").Value = Ample
                        .GFields("PEATONAL").Value = rsr.GFields("PEATONAL").Value
                        .GFields("CBICI").Value = rsr.GFields("CBICI").Value
                        .GFields("Geometry").Value = rsr.GFields("Geometry").Value
                        '     .GFields("ID").Value = j
                        .Update()
                    End With

                End If
                'Si el nombre de carrils es parell la distancia de l'eix del carrer ser multiple de l'amplada de carril
                'si es imparell hem de comenar a 1/2 amplada
                ' si es parell Hem de posar una lnia de separaci per costat per cada 2 carrils que afegim, 
                'p.ex: 2 carrils noms la del mig, 4 carrils 1 a cada costat, 6 carrils 2 a cada costat -Z
                ' Aleshores: 8 carrils=3 -> 8/2 -1, 6 carrils=2 -> 6/2 -1, 4 carrils =1 -> 4/2-1     
                For Contador = 1 To (nCarrils \ 2) - 1

                    rightOffset = New PBasic.PolylineGeometry
                    leftOffset = New PBasic.PolylineGeometry
                    If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                        'Si el nombre de carrils es parell:
                        auxBol = Paralela1(Geomt, Ample * Contador, rightOffset, leftOffset)
                    Else
                        auxBol = Paralela1(Geomt, Ample / 2 * Contador, rightOffset, leftOffset)
                    End If

                    'Guardem el costat dret
                    objGSS.GeometryToStorage(rightOffset, cnk)
                    With rsw
                        .AddNew()
                        .GFields("IDTRAM").Value = IdTram
                        .GFields("CARRILS").Value = nCarrils
                        .GFields("AMPLADA").Value = Ample
                        .GFields("Geometry").Value = cnk
                        '       .GFields("ID").Value = j

                    End With
                    rsw.Update()
                    objGSS = Nothing
                    cnk = Nothing
                    objGSS = New PClient.GeometryStorageServiceClass
                    cnk = New Object
                    objGSS.GeometryToStorage(leftOffset, cnk)
                    'Guardem el costat esquerre
                    With rsw
                        .AddNew()
                        .GFields("IDTRAM").Value = IdTram
                        .GFields("CARRILS").Value = nCarrils
                        .GFields("AMPLADA").Value = Ample
                        .GFields("Geometry").Value = cnk

                    End With
                    rsw.Update()



                Next


            End If





            l = l + 1
            rsr.MoveNext()
            ProgressBar1.Value = l
            Me.Refresh()
        End While
        lblProgres.Text = "Taula carrils creada"

        objGSS = Nothing
        rsr.Close()
        rsw.Close()
        objDB.Close()
        objDB2.Close()

    End Sub
    Function Paralela1(ByVal Geomt As Object, ByVal Amplada As Double, ByRef rigthOfset As PBasic.PolylineGeometry, ByRef leftOfset As PBasic.PolylineGeometry) As Boolean
        Dim PntIni As New PBasic.point
        Dim pntFi As New PBasic.point
        Dim Angle As Double, incX As Double, incY As Double
        Dim pnt0 As New PBasic.point
        Dim pnt1 As New PBasic.point
        Dim pnt2 As New PBasic.point
        Dim pnt3 As New PBasic.point
        '  Dim GpolyLine = New PBasic.PolylineGeometry
        Dim i As Integer

        rigthOfset = New PBasic.PolylineGeometry
        leftOfset = New PBasic.PolylineGeometry
        'pnt0.X = Geomt.Points(1).x
        'pnt0.Y = Geomt.Points(1).y
        'Gpoly.Points.Add(pnt0)
        Try


            For i = 1 To Geomt.Points.Count - 1


                'Crear Punts dels contorn a partir amplada,....


                ' Calculem l'angle
                Angle = CalcularAngle(Geomt.Points(i), Geomt.Points(i + 1))
                'If sentit Then 'Part dreta
                Angle = Angle + (Math.PI / 2)
                ' Else
                ' Angle = Angle - (Math.PI / 2)
                'End If

                'un cop tenim l'angle calculem els punts

                'x = x0 + d * sen(Angle)
                pnt1.X = Geomt.Points(i).x + (Amplada * Math.Cos(Angle))
                'y=y0 + d * cos (Angle)
                pnt1.Y = Geomt.Points(i).y + (Amplada * Math.Sin(Angle))
                leftOfset.Points.Add(pnt1)

            Next
            'Calculem els increments
            incY = Geomt.Points(Geomt.Points.Count).Y - Geomt.Points(Geomt.Points.Count - 1).Y
            incX = Geomt.Points(Geomt.Points.Count).x - Geomt.Points(Geomt.Points.Count - 1).x

            'Fem l'ltim punt:
            pnt1.X = pnt1.X + incX
            pnt1.Y = pnt1.Y + incY
            leftOfset.Points.Add(pnt1)

            For i = 1 To Geomt.Points.Count - 1


                'Crear Punts dels contorn a partir amplada,....


                ' Calculem l'angle
                Angle = CalcularAngle(Geomt.Points(i), Geomt.Points(i + 1))
                'If sentit Then 'Part dreta
                Angle = Angle - (Math.PI / 2)
                ' Else
                ' Angle = Angle - (Math.PI / 2)
                'End If

                'un cop tenim l'angle calculem els punts

                'x = x0 + d * sen(Angle)
                pnt1.X = Geomt.Points(i).x + (Amplada * Math.Cos(Angle))
                'y=y0 + d * cos (Angle)
                pnt1.Y = Geomt.Points(i).y + (Amplada * Math.Sin(Angle))
                rigthOfset.Points.Add(pnt1)

            Next

            ' l'altre costat
            'Calculem els increments
            incY = Geomt.Points(Geomt.Points.Count).Y - Geomt.Points(Geomt.Points.Count - 1).Y
            incX = Geomt.Points(Geomt.Points.Count).x - Geomt.Points(Geomt.Points.Count - 1).x

            'Fem l'ltim punt:
            pnt1.X = pnt1.X + incX
            pnt1.Y = pnt1.Y + incY
            rigthOfset.Points.Add(pnt1)



            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function


    Sub crearPoligonsTipus(ByVal Tipus As String, ByVal Camp As String)
        Dim objGSS As New PClient.GeometryStorageServiceClass, rsw As GDO.GRecordset, rsAmplada As GDO.GRecordset
        Dim Geomt As Object, pnt As New PBasic.point, pntInit As New PBasic.point
        Dim pntCentre As New PBasic.PolylineGeometry, pntIni As PBasic.point, pntFi As PBasic.point
        Dim cnk As Object, nCarrils As Integer, sql As String
        Dim Gpoly As PBasic.PolygonGeometryClass
        Dim Gpoly2 As PBasic.PolygonGeometryClass
        Dim leftOffset As New PBasic.PolylineGeometry, rightOffset As New PBasic.PolylineGeometry
        Dim leftOffset2 As New PBasic.PolylineGeometry, rightOffset2 As New PBasic.PolylineGeometry
        Dim Centroide As New PBasic.point
        Dim auxBol As Boolean, Ample As Double, contador As Integer

        Dim rsr As GDO.GRecordset
        Dim rutabd As String, rutabd2 As String
        Dim nPunt As Integer


        Dim objDB As GDO.GDatabase
        Dim objDB2 As GDO.GDatabase

        objDB = CreateObject("Access.GDatabase")
        objDB2 = CreateObject("Access.GDatabase")
        rutabd = "C:\UOC\SIG\dades complementaries\Exemples1\Exemples1.mdb"
        rutabd2 = "C:\Temp\" & Me.TextBox1.Text & ".mdb"

        Try

            objDB.OpenDatabase("C:\UOC\SIG\dades complementaries\Exemples1\Exemples1.mdb", , True)
            objDB2.OpenDatabase("C:\Temp\" & Me.TextBox1.Text & ".mdb")

        Catch
            'Si no ha pogut obrir la base de dades a la ruta per defecte demana la ruta a l'usuari
            rutabd = (InputBox("Ruta de la base de dades: ", "Indicar la ruta de la base de dades (fitxer mdb)"))
            objDB.OpenDatabase(rutabd)
        End Try

        sql = "select * from " & Tipus
        rsr = objDB.OpenRecordset("select * from TRAMS", GDO.GConstants.gdbOpenDynaset)
        rsw = objDB2.OpenRecordset(sql, GDO.GConstants.gdbOpenDynaset)

        Dim l As Integer
        l = 0
        lblProgres.Text = "Omplint taula " & Tipus

        'Recorrem la taula
        While Not rsr.EOF

            With ProgressBar1
                .Maximum = rsr.RecordCount()
                .Minimum = 0

            End With


            objGSS.GetGeometry(rsr.GFields("Geometry"), Geomt)


            If rsr.GFields(Camp).Value > 0 Then 'si es carril bici

                'Mirem l'amplada del carril
                rsAmplada = objDB.OpenRecordset("select * from CARRILS Where IDTRAM=" & rsr.GFields("IDTRAM").Value, GDO.GConstants.gdbOpenDynaset)

                Try

                    Ample = rsAmplada.GFields(3).Value
                Catch
                    'Si no hi ha informacio de l'amplada possem 3
                    Ample = 3
                End Try

                nCarrils = rsr.GFields("CARRILS").Value



                rightOffset = New PBasic.PolylineGeometry
                leftOffset = New PBasic.PolylineGeometry
                If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                    'Si el nombre de carrils es parell:
                    auxBol = Paralela1(Geomt, Ample, rightOffset, leftOffset)
                    Gpoly = crearPoligon(rightOffset, Geomt)
                Else
                    auxBol = Paralela1(Geomt, Ample / 2, rightOffset, leftOffset)
                    Gpoly = crearPoligon(rightOffset, leftOffset)
                End If
                'Guardem el poligon
                objGSS = New PClient.GeometryStorageService
                cnk = New Object
                objGSS.GeometryToStorage(Gpoly, cnk)
                'Guardem el poligon
                With rsw
                    .AddNew()
                    .GFields("IDTRAM").Value = rsr.GFields("IDTRAM").Value
                    .GFields("Geometry").Value = cnk
                    '.GFields("IDB").Value = j
                    If Camp.Equals("CBICI") Then
                        'punt mig
                        nPunt = Geomt.Points.Count \ 2

                        pntIni = Geomt.Points(nPunt)
                        pntFi = Geomt.Points(nPunt + 1)
                        Dim pntAux As New PBasic.point
                        pntAux.X = (pntIni.X + pntFi.X) / 2
                        pntAux.Y = (pntIni.Y + pntFi.Y) / 2
                        pntCentre.Points.Add(pntAux)
                        .GFields("CentreX").Value = pntAux.X
                        .GFields("CentreY").Value = pntAux.Y

                        Dim GeomBlob As Object
                        'Guardem el punt
                        objGSS = New PClient.GeometryStorageService

                        GeomBlob = New Object
                        objGSS.GeometryToStorage(pntCentre, GeomBlob)
                        .GFields("Centroide").Value = GeomBlob
                    End If
                    'Dim GeomField As GDO.GField
                    'GeomField = rsw.GFields("Centroide")

                    'objGSS.SetGeometry(GeomField, pntCentre)
                    'GeomField = rsw.GFields("GEOMETRY")

                    ' objGSS.SetGeometry(GeomField, pntCentre)
                    'GRecordset.Update()
                    'GeomField = Nothing

                End With
                '

                rsw.Update()
                'Si es parell s'ha de guardar l'altre poligon
                If nCarrils Mod 2 = 0 Then

                    Gpoly = crearPoligon(leftOffset, Geomt)
                    'Guardem el poligon
                    objGSS = New PClient.GeometryStorageService
                    cnk = New Object
                    objGSS.GeometryToStorage(Gpoly, cnk)
                    'Guardem el poligon
                    With rsw
                        .AddNew()
                        .GFields("IDTRAM").Value = rsr.GFields("IDTRAM").Value
                        .GFields("Geometry").Value = cnk
                        ' .GFields("IDB").Value = j

                        If Camp.Equals("CBICI") Then
                            'punt mig
                            nPunt = Geomt.Points.Count \ 2

                            pntIni = Geomt.Points(nPunt)
                            pntFi = Geomt.Points(nPunt + 1)
                            Dim pntAux As New PBasic.point
                            pntAux.X = (pntIni.X + pntFi.X) / 2
                            pntAux.Y = (pntIni.Y + pntFi.Y) / 2
                            pntCentre.Points.Add(pntAux)
                            .GFields("CentreX").Value = pntAux.X
                            .GFields("CentreY").Value = pntAux.Y

                            Dim GeomBlob As Object
                            'Guardem el punt
                            objGSS = New PClient.GeometryStorageService

                            GeomBlob = New Object
                            objGSS.GeometryToStorage(pntCentre, GeomBlob)
                            .GFields("Centroide").Value = GeomBlob
                        End If
                    End With
                    rsw.Update()

                End If


                If nCarrils > 1 Then 'si hi ha ms dn carril


                    For contador = 1 To (nCarrils \ 2) - 1


                        If nCarrils Mod 2 = 0 Then 'Retorna 0 si es parell, 1 imparell.
                            'Si el nombre de carrils es parell:
                            auxBol = Paralela1(Geomt, Ample, rightOffset, leftOffset)
                            auxBol = Paralela1(Geomt, 2 * Ample, rightOffset2, leftOffset2)


                        Else
                            auxBol = Paralela1(Geomt, Ample / 2, rightOffset, leftOffset)
                            auxBol = Paralela1(Geomt, Ample * 1.5, rightOffset2, leftOffset2)
                            Gpoly = crearPoligon(rightOffset, leftOffset)
                        End If

                        Gpoly = crearPoligon(rightOffset, rightOffset2)
                        Gpoly2 = crearPoligon(leftOffset, leftOffset2)

                        'Guardem els poligons
                        objGSS = New PClient.GeometryStorageService
                        cnk = New Object
                        objGSS.GeometryToStorage(Gpoly, cnk)
                        'Guardem el poligon
                        With rsw
                            .AddNew()
                            .GFields("IDTRAM").Value = rsr.GFields("IDTRAM").Value
                            .GFields("Geometry").Value = cnk
                            If Camp.Equals("CBICI") Then
                                'punt mig
                                nPunt = Geomt.Points.Count \ 2

                                pntIni = Geomt.Points(nPunt)
                                pntFi = Geomt.Points(nPunt + 1)
                                Dim pntAux As New PBasic.point
                                pntAux.X = (pntIni.X + pntFi.X) / 2
                                pntAux.Y = (pntIni.Y + pntFi.Y) / 2
                                pntCentre.Points.Add(pntAux)
                                .GFields("CentreX").Value = pntAux.X
                                .GFields("CentreY").Value = pntAux.Y

                                Dim GeomBlob As Object
                                'Guardem el punt
                                objGSS = New PClient.GeometryStorageService

                                GeomBlob = New Object
                                objGSS.GeometryToStorage(pntCentre, GeomBlob)
                                .GFields("Centroide").Value = GeomBlob
                            End If
                        End With
                        rsw.Update()



                        objGSS = New PClient.GeometryStorageServiceClass
                        cnk = New Object
                        objGSS.GeometryToStorage(Gpoly2, cnk)
                        'Guardem el poligon
                        With rsw
                            .AddNew()
                            .GFields("IDTRAM").Value = rsr.GFields("IDTRAM").Value
                            .GFields("Geometry").Value = cnk
                            If Camp.Equals("CBICI") Then
                                'punt mig
                                nPunt = Geomt.Points.Count \ 2

                                pntIni = Geomt.Points(nPunt)
                                pntFi = Geomt.Points(nPunt + 1)
                                Dim pntAux As New PBasic.point
                                pntAux.X = (pntIni.X + pntFi.X) / 2
                                pntAux.Y = (pntIni.Y + pntFi.Y) / 2
                                pntCentre.Points.Add(pntAux)
                                .GFields("CentreX").Value = pntAux.X
                                .GFields("CentreY").Value = pntAux.Y

                                Dim GeomBlob As Object
                                'Guardem el punt
                                objGSS = New PClient.GeometryStorageService

                                GeomBlob = New Object
                                objGSS.GeometryToStorage(pntCentre, GeomBlob)
                                .GFields("Centroide").Value = GeomBlob
                            End If
                        End With
                        rsw.Update()






                    Next



                End If

            End If

            l = l + 1

            ProgressBar1.Value = l
            rsr.MoveNext()

            Me.Refresh()
        End While
        objGSS = Nothing
        rsAmplada.Close()


        objDB.Close()
        objDB.Close()
        'rsr.Close()
        rsw.Close()
        txtX.Text = "TAULA PLENA"
        lblProgres.Text = "Taula  Carrils " & Tipus & "Creada"


    End Sub
    Function crearPoligon(ByVal rigthPolyLine, ByVal leftPolyLine) As PBasic.PolygonGeometry
        Dim i As Integer
        Dim Poly As New PBasic.PolygonGeometry
        For i = 1 To rigthPolyLine.Points.Count

            Poly.Points.Add(rigthPolyLine.Points.Item(i))
        Next
        ' costat esquerre

        For i = leftPolyLine.Points.Count To 1 Step -1

            Poly.Points.Add(leftPolyLine.Points.Item(i))
        Next
        'Posem el darrer al principi
        Poly.Points.Add(Poly.Points.Item(1))
        Return Poly

    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        crearTaules()
        crearPoligonsCarrers()

        crearEixosCarrils()
        crearPoligonsTipus("Carrils_Bici", "CBICI")
        crearPoligonsTipus("Carrils_Peatonals", "PEATONAL")
        crearPoligonsTipus("Carrils", "IDTRAM")


    End Sub
End Class